<?php

define("IDPAY_API_KEY", "api در اینجا");

function httpRequestPost(string $url, array $body_list = [])
{
    $body = json_encode($body_list);
    $body_length = strlen($body);

    $api_key = IDPAY_API_KEY;

    $opts = array(
        'http' =>
        array(
            'method'  => 'POST',
            'header'  => "Content-Type: application/json\r\n" . "Content-Length: {$body_length}\r\n" . "X-API-KEY: {$api_key}\r\n" . "X-SANDBOX: 1\r\n",
            'content' => $body,
            'timeout' => 60
        )
    );

    $context  = stream_context_create($opts);
    $result = @file_get_contents($url, false, $context);

    if ($result) $result = json_decode($result, true);

    return $result;
}

function requestIdPay($amount, $order_id, $description = "")
{
    $body = [
        "amount" => $amount,
        "order_id" => $order_id,
        "desc" => $description,
        "callback" => "http://example.com/payment/idpay.php",
    ];

    $res = httpRequestPost("https://api.idpay.ir/v1.1/payment", $body);

    return (is_array($res) && @$res['link']) ? $res['link'] : false;
}

function payIdPay($link)
{
    $action_url = $link;
    return $action_url;
}

function verifyIdPay($id, $order_id)
{
    $body = array(
        "id" => $id,
        "order_id" => $order_id,
    );

    $res = httpRequestPost('https://api.idpay.ir/v1.1/payment/verify', $body);

    return $res;
}
